#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
//#include <netinet/ether.h>
//#include <pthread.h>
//#include <sys/socket.h>
//#include <netinet/in.h>


#define OFFSET_FLAG 0
#define AP_CONFIG_BLOCK  "/dev/mtdblock3"
#define ETH0_OFFSET		0x00
#define ETH1_OFFSET		0x06
#define MAC_ADDR_OFFSET_2G 	0x1000+2
#define MAC_ADDR_OFFSET_5G 	0x5000+2


int writeProductData(unsigned char *data, int pos, int len)
{
	char *dev_name;
	int nwrite;
	int fd;
	dev_name = AP_CONFIG_BLOCK;
	fd = open(dev_name, O_WRONLY | O_NONBLOCK);
	if(fd < 0)
	{
		printf("open %s error: %m\n", dev_name);
		return -1;
	}

	if(lseek(fd, pos, 0) < 0)
	{
		printf("offset value error: %m\n");
		return -1;
	 }
	nwrite = write(fd, data, len);
	if(nwrite < 0)
	{
		printf("write %s error: %m\n", dev_name);
		close(fd);
		return -1;
	}
	close(fd);
	system("sync");
	system("sync");
	system("sync");
	return 0;
}



int readProductData(unsigned char *data, int pos, int len)
{
	char *dev_name;
	int nread;
	int fd;
	dev_name = AP_CONFIG_BLOCK;
	fd = open(dev_name, O_RDONLY | O_NONBLOCK);
	if(fd < 0)
	{
		printf("open %s error: %m\n", dev_name);
		return -1;
	}
	if( lseek(fd,pos,0) < 0)
	{
		printf("offset value error: %m\n");
		return -1;
	 }
	nread = read(fd, data, len);

	//printf("func == %s line ==%d data ==%s\n\n",__func__,__LINE__,data);
	if(nread < 0)
	{
		printf("write %s error: %m\n", dev_name);
		close(fd);
		return -1;
	}
	close(fd);
	return 0;
}

int macstring_to_bytes(unsigned char *src, unsigned char *dst)
{
	int i,j;
	unsigned char str[64];
	
	for(i=0; i<12; i++){
		if(src[i]>=48 && src[i]<=57){
			str[i] = src[i] - 48;
		}else if(src[i]>=65 && src[i]<=70){
			str[i] = src[i] - 65 + 0xa;
		}else if(src[i]>=97 && src[i]<=102){
			str[i] = src[i] - 97 + 0xa;
		}else{
			return -1;
		}	
	}

	dst[0] = str[0]*16+str[1];
	dst[1] = str[2]*16+str[3];
	dst[2] = str[4]*16+str[5];
	dst[3] = str[6]*16+str[7];
	dst[4] = str[8]*16+str[9];
	dst[5] = str[10]*16+str[11];
	return 0;
	}

int main(int argc,char **argv){

	int offset, rv;
	unsigned char *macStr = NULL ;
	unsigned char buf_tmp[64];
	unsigned char data[64];
	int i = 0,len=6;
	
	
	
	if(argc == 2)
	{
		if(0 == strcmp(argv[1], "?")){
			printf("macconfig:	modified MAC address\n");
			printf("please input like this:macconfig 001122334455\n");
			return -1;
		}else{
			offset = OFFSET_FLAG;
			macStr = (unsigned char*)argv[1];
			if(12 != strlen(macStr)){
				printf("The length of the MAC address errors\n");
				return -1;
			}
		}	
	}else{
		printf("The input parameter errors,please input like this: macconfig 001122334455\n");
		return -1;
	}
	
	
	//strcpy(data, macStr);
	rv = macstring_to_bytes(macStr, data);
	if(rv <0){
		printf ("MAC addr input error\n");
		return -1;
	}
	//printf("data=%x%x%x%x%x%x\n",data[0], data[1],data[2],data[3],data[4],data[5]);
	/*read MAC after writed MAC,check if they are the same to each other
				if not,try to write 3 times again */
	for(i=0;i<3;i++)
	{
		bzero(buf_tmp, len);
		writeProductData(data, offset, len);
		usleep(200);
		readProductData(buf_tmp, offset, len);
		if(memcmp(data, buf_tmp, len) != 0)
		{
			printf("check error,write product information again\n");
		}
		else
		{
			printf("write product information successful!\n");
			return 0;
		}
	}

}





